/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 *  
 */

package org.teiid.query.sql.symbol;

import java.util.List;

import org.teiid.core.types.DataTypeManager;
import org.teiid.core.util.EquivalenceUtil;
import org.teiid.core.util.HashCodeUtil;
import org.teiid.query.sql.LanguageObject;
import org.teiid.query.sql.LanguageVisitor;
import org.teiid.query.sql.visitor.SQLStringVisitor;


/**
 * Represents XMLATTRIBUTES/XMLFOREST name value pairs
 */
public class XMLElement implements Expression {

	private static final long serialVersionUID = -3348922701950966494L;
	private String name;
	private DerivedColumn nameExpr;
	private boolean evalName;
	private XMLNamespaces namespaces;
	private XMLAttributes attributes;
	private List<Expression> content;

	public XMLElement(String name, DerivedColumn nameExpr, boolean evalName, List<Expression> content) {
		this.name = name;
		this.nameExpr = nameExpr;
		this.evalName = evalName;
		this.content = content;
	}

	public XMLElement(String name, List<Expression> content) {
		this(name, null, false, content);
	}
	
	public XMLAttributes getAttributes() {
		return attributes;
	}
	
	public XMLNamespaces getNamespaces() {
		return namespaces;
	}
	
	public void setAttributes(XMLAttributes attributes) {
		this.attributes = attributes;
	}
	
	public void setNamespaces(XMLNamespaces namespaces) {
		this.namespaces = namespaces;
	}
	
	public List<Expression> getContent() {
		return content;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public DerivedColumn getNameExpr() {
		return nameExpr;
	}

	public void setNameExpr(DerivedColumn nameExpr) {
		this.nameExpr = nameExpr;
	}

	public boolean isEvalName() {
		return evalName;
	}

	public void setEvalName(boolean evalName) {
		this.evalName = evalName;
	}

	public void setContent(List<Expression> args) {
		this.content = args;
	}

	@Override
	public Class<?> getType() {
		return DataTypeManager.DefaultDataClasses.XML;
	}

	@Override
	public void acceptVisitor(LanguageVisitor visitor) {
		visitor.visit(this);
	}
		
	@Override
	public XMLElement clone() {
		XMLElement clone = new XMLElement(name, evalName ? nameExpr.clone() : null, evalName, LanguageObject.Util.deepClone(content, Expression.class));
		if (namespaces != null) {
			clone.setNamespaces(namespaces.clone());
		}
		if (attributes != null) {
			clone.setAttributes(attributes.clone());
		}
		return clone;
	}
	
	@Override
	public int hashCode() {
		int nameHash = name != null ? name.toUpperCase().hashCode() : 0;
		int nameExprHash = nameExpr != null ? nameExpr.hashCode() : 0;
		return HashCodeUtil.hashCode(nameHash, nameExprHash, evalName, content.hashCode());
	}
	
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (!(obj instanceof XMLElement)) {
			return false;
		}
		XMLElement other = (XMLElement)obj;
		return EquivalenceUtil.areEqual(name, other.name) && EquivalenceUtil.areEqual(nameExpr, other.nameExpr) && EquivalenceUtil.areEqual(evalName, other.evalName) &&
				content.equals(other.content) && EquivalenceUtil.areEqual(this.namespaces, other.namespaces);
	}
	
	@Override
	public String toString() {
		return SQLStringVisitor.getSQLString(this);
	}
	
}
